******* This code produces most results for the graphs and Hambur and La Cava (2018)
** Makes uses of ivreg2 package

* Make sure working directory has data file in it
local location ""

* Set to directory with ivreg2 package and rantest package installed
sysdir set PLUS ""

use "`location'\Main_data_file.dta", clear

**** Figures

***Figure 1

* Middle panel 
table year if Res!=1, c(p10 irliabtot med irliabtot p90 irliabtot)


***Figure 2

*Small 
table year if Res!=1 & small == 1, c(med irliabtot )

*Medium 
table year if Res!=1 & medium == 1, c(med irliabtot )

*Large 
table year if Res!=1 & large == 1, c(med irliabtot )


*** Figure 3

*Left panel
table year risky if Res!=1, c(med irliabtot)

*Right panel
table year risky if Res!=1, c(med D2D)

*** Figure 4
table year if Res!=1, c(min coe_sec med coe_sec max coe_sec)

*** Figure 5
table year if Res!=1, c(p10 coe_adj med coe_adj p90 coe_adj)

*** Figure 6

* Top panel
xtset asxnum year
g lag_ir = l.irliabtot
table year if Res!=1 , c(med lag_ir med cof_adj_ir med cof_adj_ir)
drop lag_ir

table year if Res!=1 , c(med Inv_ppe_st_k med Inv_ppe_cash_k)

*** Figure 7 - see xt_irf.do

**** Tables

*** Table 1

*Net investment
xi: xtabond Inv_ppe_st_k l2.lk_ppe l(0/1).d.lrsales l2.lrsales l(1/2).d.lir l3.lir i.year if Inv_ppe_st_k<=Inv_ppe_st_k_p95 & Inv_ppe_st_k>=Inv_ppe_st_k_p5 & year<=2015 & Res!=1, robust

*Gross investment
xi: xtabond Inv_ppe_cash_k l2.lk_ppe l(0/1).d.lrsales l2.lrsales l(1/2).d.lir l3.lir i.year if Inv_ppe_cash_k<=Inv_ppe_cash_k_p95 & Inv_ppe_cash_k>=Inv_ppe_cash_k_p5 & year<=2015 & Res!=1, robust

*** Table 1

** Firm-specific
*Net investment
xi: xtabond Inv_ppe_st_k l2.lk_ppe l(0/1).d.lrsales l2.lrsales l(0/1).d.lcof_adj_ir l2.lcof_adj_ir i.year if Inv_ppe_st_k<=Inv_ppe_st_k_p95 & Inv_ppe_st_k>=Inv_ppe_st_k_p5 & year<=2015 & Res!=1, robust

*Gross investment.
xi: xtabond Inv_ppe_cash_k l2.lk_ppe l(0/1).d.lrsales l2.lrsales l(0/1).d.lcof_adj_ir l2.lcof_adj_ir i.year if Inv_ppe_cash_k<=Inv_ppe_cash_k_p95 & Inv_ppe_cash_k>=Inv_ppe_cash_k_p5 & year<=2015 & Res!=1, robust

** Sectoral
*Net investment
xi: xtabond Inv_ppe_st_k l2.lk_ppe l(0/1).d.lrsales l2.lrsales l(0/1).d.lcof_ir_sec l2.lcof_ir_sec i.year if Inv_ppe_st_k<=Inv_ppe_st_k_p95 & Inv_ppe_st_k>=Inv_ppe_st_k_p5 & year<=2015 & Res!=1, robust


*Gross investment.
xi: xtabond Inv_ppe_cash_k l2.lk_ppe l(0/1).d.lrsales l2.lrsales l(0/1).d.lcof_ir_sec l2.lcof_ir_sec i.year if Inv_ppe_cash_k<=Inv_ppe_cash_k_p95 & Inv_ppe_cash_k>=Inv_ppe_cash_k_p5 & year<=2015 & Res!=1 , robust


*** Table 3 - see Multiple imputation code.do

*** Table C1

* Net investment
xi: ivreg2 Inv_ppe_st_k i.year i.asxnum i.industry l.Q l.d.lir l.D2D if Inv_ppe_st_k<=Inv_ppe_st_k_p95 & Inv_ppe_st_k>=Inv_ppe_st_k_p5 & Res!=1, robust cluster(asxnum) partial(i.industry i.asxnum)

*Gross investment
xi: ivreg2 Inv_ppe_cash_k i.year i.asxnum i.industry l.Q l.d.lir l.D2D if Inv_ppe_cash_k<=Inv_ppe_cash_k_p95 & Inv_ppe_cash_k>=Inv_ppe_cash_k_p5 & Res!=1, robust cluster(asxnum) partial(i.industry i.asxnum)


